wxURL Class Reference | wxWidgets

| Version: 3.2.11

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
wxURL Class Reference
Class List by Category » Networking

`#include </cygdrive/c/Users/Hamis/Cygwin-packaging/wxWidgets3.2/wxWidgets3.2-3.2.11-1.x86_64/src/wxWidgets-3.2.11/interface/wx/url.h>`

Inheritance diagram for wxURL:
[legend]

## Detailed Description

wxURL is a specialization of wxURI for parsing URLs.

Please look at wxURI documentation for more info about the functions you can use to retrieve the various parts of the URL (scheme, server, port, etc).

Supports standard assignment operators, copy constructors, and comparison operators.

##

Library: wxNet
Category: Networking

See also
  wxSocketBase, wxProtocol

## Public Member Functions
| wxURL (const wxString &url=wxEmptyString)
| Constructs a URL object from the string.
virtual | ~wxURL ()
| Destroys the URL object.
wxURLError | GetError () const
| Returns the last error.
wxInputStream * | GetInputStream ()
| Creates a new input stream on the specified URL.
wxProtocol & | GetProtocol ()
| Returns a reference to the protocol which will be used to get the URL.
bool | IsOk () const
| Returns true if this object is correctly initialized, i.e. if GetError() returns wxURL_NOERR.
void | SetProxy (const wxString &url_proxy)
| Sets the proxy to use for this URL.
wxURLError | SetURL (const wxString &url)
| Initializes this object with the given URL and returns wxURL_NOERR if it's valid (see GetError() for more info).
Public Member Functions inherited from wxURI
| wxURI ()
| Creates an empty URI.
| wxURI (const wxString &uri)
| Constructor for quick creation.
| wxURI (const wxURI &uri)
| Copies this URI from another URI.
wxString | BuildURI () const
| Builds the URI from its individual components and adds proper separators.
wxString | BuildUnescapedURI () const
| Builds the URI from its individual components, adds proper separators, and returns escape sequences to normal characters.
bool | Create (const wxString &uri)
| Creates this URI from the uri string.
const wxString & | GetFragment () const
| Obtains the fragment of this URI.
wxURIHostType | GetHostType () const
| Obtains the host type of this URI, which is one of wxURIHostType.
wxString | GetPassword () const
| Returns the password part of the userinfo component of this URI.
const wxString & | GetPath () const
| Returns the (normalized) path of the URI.
const wxString & | GetPort () const
| Returns a string representation of the URI's port.
const wxString & | GetQuery () const
| Returns the Query component of the URI.
const wxString & | GetScheme () const
| Returns the Scheme component of the URI.
const wxString & | GetServer () const
| Returns the Server component of the URI.
wxString | GetUser () const
| Returns the username part of the userinfo component of this URI.
const wxString & | GetUserInfo () const
| Returns the UserInfo component of the URI.
bool | HasFragment () const
| Returns true if the Fragment component of the URI exists.
bool | HasPath () const
| Returns true if the Path component of the URI exists.
bool | HasPort () const
| Returns true if the Port component of the URI exists.
bool | HasQuery () const
| Returns true if the Query component of the URI exists.
bool | HasScheme () const
| Returns true if the Scheme component of the URI exists.
bool | HasServer () const
| Returns true if the Server component of the URI exists.
bool | HasUserInfo () const
| Returns true if the User component of the URI exists.
bool | IsReference () const
| Returns false if a valid [absolute] URI, otherwise this URI is a URI reference and not a full URI, and this function returns true.
void | Resolve (const wxURI &base, int flags=wxURI_STRICT)
| Inherits this URI from a base URI - components that do not exist in this URI are copied from the base, and if this URI's path is not an absolute path (prefixed by a '/'), then this URI's path is merged with the base's path.
bool | operator== (const wxURI &uricomp) const
| Compares this URI to another URI, and returns true if this URI equals uricomp, otherwise it returns false.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined.

## Static Public Member Functions
static void | SetDefaultProxy (const wxString &url_proxy)
| Sets the default proxy server to use to get the URL.
Static Public Member Functions inherited from wxURI
static wxString | Unescape (const wxString &uri)
| Translates all escape sequences (normal characters and returns the result.

## Additional Inherited Members
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

## ◆ wxURL()

wxURL::wxURL | ( | const wxString & | url = wxEmptyString | ) |

Constructs a URL object from the string.

The URL must be valid according to RFC 1738. In particular, file URLs must be of the format `"file://hostname/path/to/file"`, otherwise GetError() will return a value different from wxURL_NOERR.

It is valid to leave out the hostname but slashes must remain in place, in other words, a file URL without a hostname must contain three consecutive slashes (e.g. `"file:///somepath/myfile"`).

Parameters

  url | Url string to parse.

## ◆ ~wxURL()

virtual wxURL::~wxURL | ( |  | ) |
| virtual

Destroys the URL object.

## Member Function Documentation

## ◆ GetError()

wxURLError wxURL::GetError | ( |  | ) | const

Returns the last error.

This error refers to the URL parsing or to the protocol. It can be one of wxURLError.

## ◆ GetInputStream()

wxInputStream * wxURL::GetInputStream | ( |  | ) |

Creates a new input stream on the specified URL.

You can use all but seek functionality of wxStream. Seek isn't available on all streams. For example, HTTP or FTP streams don't deal with it.

Note that this method is somewhat deprecated, all future wxWidgets applications should use wxFileSystem instead.

Example:

wxURL url("http://a.host/a.dir/a.file");
if (url.GetError() == wxURL_NOERR)
{
wxInputStream *in_stream;
in_stream = url.GetInputStream();
// Then, you can use all IO calls of in_stream (See wxStream)
}
wxInputStream
wxInputStream is an abstract base class which may not be used directly.
Definition stream.h:580
wxURL::wxURL
wxURL(const wxString &url=wxEmptyString)
Constructs a URL object from the string.
wxURL_NOERR
@ wxURL_NOERR
No error.
Definition url.h:12

Returns
  Returns the initialized stream. You will have to delete it yourself.

See also
  wxInputStream

## ◆ GetProtocol()

wxProtocol & wxURL::GetProtocol | ( |  | ) |

Returns a reference to the protocol which will be used to get the URL.

## ◆ IsOk()

bool wxURL::IsOk | ( |  | ) | const

Returns true if this object is correctly initialized, i.e. if GetError() returns wxURL_NOERR.

## ◆ SetDefaultProxy()

void wxURL::SetDefaultProxy | ( | const wxString & | url_proxy | ) |
| static

Sets the default proxy server to use to get the URL.

The string specifies the proxy like this: `"<hostname>:<port number>"`.

Parameters

  url_proxy | Specifies the proxy to use.

See also
  SetProxy()

## ◆ SetProxy()

void wxURL::SetProxy | ( | const wxString & | url_proxy | ) |

Sets the proxy to use for this URL.

See also
  SetDefaultProxy()

## ◆ SetURL()

wxURLError wxURL::SetURL | ( | const wxString & | url | ) |

Initializes this object with the given URL and returns wxURL_NOERR if it's valid (see GetError() for more info).